首页 > 代码库 > hdu4035----Maze
hdu4035----Maze
Maze
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65768/65768 K (Java/Others)Total Submission(s): 1788 Accepted Submission(s): 701
Special Judge
Problem Description
When wake up, lxhgww find himself in a huge maze.
The maze consisted by N rooms and tunnels connecting these rooms. Each pair of rooms is connected by one and only one path. Initially, lxhgww is in room 1. Each room has a dangerous trap. When lxhgww step into a room, he has a possibility to be killed and restart from room 1. Every room also has a hidden exit. Each time lxhgww comes to a room, he has chance to find the exit and escape from this maze.
Unfortunately, lxhgww has no idea about the structure of the whole maze. Therefore, he just chooses a tunnel randomly each time. When he is in a room, he has the same possibility to choose any tunnel connecting that room (including the tunnel he used to come to that room).
What is the expect number of tunnels he go through before he find the exit?
The maze consisted by N rooms and tunnels connecting these rooms. Each pair of rooms is connected by one and only one path. Initially, lxhgww is in room 1. Each room has a dangerous trap. When lxhgww step into a room, he has a possibility to be killed and restart from room 1. Every room also has a hidden exit. Each time lxhgww comes to a room, he has chance to find the exit and escape from this maze.
Unfortunately, lxhgww has no idea about the structure of the whole maze. Therefore, he just chooses a tunnel randomly each time. When he is in a room, he has the same possibility to choose any tunnel connecting that room (including the tunnel he used to come to that room).
What is the expect number of tunnels he go through before he find the exit?
Input
First line is an integer T (T ≤ 30), the number of test cases.
At the beginning of each case is an integer N (2 ≤ N ≤ 10000), indicates the number of rooms in this case.
Then N-1 pairs of integers X, Y (1 ≤ X, Y ≤ N, X ≠ Y) are given, indicate there is a tunnel between room X and room Y.
Finally, N pairs of integers Ki and Ei (0 ≤ Ki, Ei ≤ 100, Ki + Ei ≤ 100, K1 = E1 = 0) are given, indicate the percent of the possibility of been killed and exit in the ith room.
At the beginning of each case is an integer N (2 ≤ N ≤ 10000), indicates the number of rooms in this case.
Then N-1 pairs of integers X, Y (1 ≤ X, Y ≤ N, X ≠ Y) are given, indicate there is a tunnel between room X and room Y.
Finally, N pairs of integers Ki and Ei (0 ≤ Ki, Ei ≤ 100, Ki + Ei ≤ 100, K1 = E1 = 0) are given, indicate the percent of the possibility of been killed and exit in the ith room.
Output
For each test case, output one line “Case k: ”. k is the case id, then the expect number of tunnels lxhgww go through before he exit. The answer with relative error less than 0.0001 will get accepted. If it is not possible to escape from the maze, output “impossible”.
Sample Input
3 3 1 2 1 3 0 0 100 0 0 100 3 1 2 2 3 0 0 100 0 0 100 6 1 2 2 3 1 4 4 5 4 6 0 0 20 30 40 30 50 50 70 10 20 60
Sample Output
Case 1: 2.000000 Case 2: impossible Case 3: 2.895522
Source
The 36th ACM/ICPC Asia Regional Chengdu Site —— Online Contest
Recommend
概率dp,状态方程想到了,但是没有去化简,看了kuangbin的博客做的,自己在纸上也试着推了一遍,看来以后做概率dp的时候如果感觉想到方程但没什么思路就多化化简.
概率dp,状态方程想到了,但是没有去化简,看了kuangbin的博客做的,自己在纸上也试着推了一遍,看来以后做概率dp的时候如果感觉想到方程但没什么思路就多化化简.
/************************************************************************* > File Name: hdu4035.cpp > Author: ALex > Mail: 405045132@qq.com > Created Time: 2014年12月21日 星期日 17时19分33秒 ************************************************************************/ #include <map> #include <set> #include <queue> #include <stack> #include <vector> #include <cmath> #include <cstdio> #include <cstdlib> #include <cstring> #include <iostream> #include <algorithm> using namespace std; const int N = 10010; const double eps = 1e-9; int n; double k[N], e[N]; double A[N], B[N], C[N]; vector <int> edge[N]; bool dfs(int u, int fa) { int m = edge[u].size(); A[u] = m * k[u]; B[u] = (1 - k[u] - e[u]); C[u] = m * (1 - k[u] - e[u]); double f = m; for (int i = 0; i < m; ++i) { int v = edge[u][i]; if (v == fa) { continue; } if (!dfs(v, u)) { return false; } A[u] += (1 - k[u] - e[u]) * A[v]; C[u] += (1 - k[u] - e[u]) * C[v]; f -= (1 - k[u] - e[u]) * B[v]; } if (abs(f) <= eps) { return false; } A[u] /= f; B[u] /= f; C[u] /= f; return true; } int main() { int t; int u, v; scanf("%d", &t); int icase = 1; while (t--) { memset (A, 0, sizeof(A)); memset (B, 0, sizeof(B)); memset (C, 0, sizeof(C)); scanf("%d", &n); for (int i = 1; i <= n; ++i) { edge[i].clear(); } for (int i = 1; i <= n - 1; ++i) { scanf("%d%d", &u, &v); edge[u].push_back(v); edge[v].push_back(u); } for (int i = 1; i <= n; ++i) { scanf("%lf%lf", &k[i], &e[i]); k[i] /= 100; e[i] /= 100; } printf("Case %d: ", icase++); if (!dfs(1, -1) || abs(A[1] - 1) <= eps) { printf("impossible\n"); } else { printf("%.6f\n", C[1] / (1 - A[1])); } } return 0; }
hdu4035----Maze
声明:以上内容来自用户投稿及互联网公开渠道收集整理发布,本网站不拥有所有权,未作人工编辑处理,也不承担相关法律责任,若内容有误或涉及侵权可进行投诉: 投诉/举报 工作人员会在5个工作日内联系你,一经查实,本站将立刻删除涉嫌侵权内容。